"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.partitionSourceFiles = exports.removeExternalSourceFiles = exports.createProject = void 0;
const ts_morph_1 = require("ts-morph");
const createProject = (projectOptions, paths) => {
    const project = new ts_morph_1.Project(projectOptions);
    if (paths)
        project.addSourceFilesAtPaths(paths);
    return project;
};
exports.createProject = createProject;
const removeExternalSourceFiles = (project) => project.getSourceFiles().filter(sourceFile => {
    if (/\/node_modules\//.test(sourceFile.getFilePath())) {
        project.removeSourceFile(sourceFile);
        return false;
    }
    return true;
});
exports.removeExternalSourceFiles = removeExternalSourceFiles;
const partitionSourceFiles = (projectFiles, productionFiles) => {
    const productionFilePaths = productionFiles.map(file => file.getFilePath());
    const usedFiles = [];
    const unusedFiles = [];
    projectFiles.forEach(projectFile => {
        if (productionFilePaths.includes(projectFile.getFilePath())) {
            usedFiles.push(projectFile);
        }
        else {
            unusedFiles.push(projectFile);
        }
    });
    return [usedFiles, unusedFiles];
};
exports.partitionSourceFiles = partitionSourceFiles;
